Codeforces Round #410 (Div. 2) C. Mike and gcd problem 贪心

来源:互联网 发布:明源软件怎么样 编辑:程序博客网 时间:2024/06/01 07:13

C. Mike and gcd problem
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Mike has a sequence A = [a1, a2, ..., an] of length n. He considers the sequence B = [b1, b2, ..., bn] beautiful if the gcd of all its elements is bigger than 1, i.e. .

Mike wants to change his sequence in order to make it beautiful. In one move he can choose an index i (1 ≤ i < n), delete numbersai, ai + 1 and put numbers ai - ai + 1, ai + ai + 1 in their place instead, in this order. He wants perform as few operations as possible. Find the minimal number of operations to make sequence A beautiful if it's possible, or tell him that it is impossible to do so.

 is the biggest non-negative number d such that d divides bi for every i (1 ≤ i ≤ n).

Input

The first line contains a single integer n (2 ≤ n ≤ 100 000) — length of sequence A.

The second line contains n space-separated integers a1, a2, ..., an (1 ≤ ai ≤ 109) — elements of sequence A.

Output

Output on the first line "YES" (without quotes) if it is possible to make sequence A beautiful by performing operations described above, and "NO" (without quotes) otherwise.

If the answer was "YES", output the minimal number of moves needed to make sequence A beautiful.

Examples
input
21 1
output
YES1
input
36 2 4
output
YES0
input
21 3
output
YES1
Note

In the first example you can simply make one move to obtain sequence [0, 2] with .

In the second example the gcd of the sequence is already greater than 1.


题意大体是根据他给定的修改方法,问最少修改多少次,使得总序列的最小公因子大于1
做法是先判断原序列最小公因子是否大于1,如果不是,则一定会改成最小公因子为偶数的序列。
为什么一定会改成最小公因子为偶数呢,可以用反证法
假设两个公因子不包括奇数k的数 a,b
经过修改后最小公因子变为奇数 k
那么也就是  (a-b)%k==0&&(a+b)%k==0
通过前式可以知道a和b是膜k同余的,a%k==b%k==x(x>=0&&x<k)
那么(a+b)%k==(2*x)%k,根据后式可知(a+b)%k==0,因为k是奇数,所以x的取值只能为0,这样和a,b互质矛盾
然后就是贪心的修改,使得序列变成全偶数
#include<stdio.h>#include<string.h>#include<math.h>#include<string>#include<algorithm>#include<queue>#include<vector>#include<map>#include<set>#define eps 1e-9#define PI 3.141592653589793#define bs 1000000007#define bsize 256#define MEM(a) memset(a,0,sizeof(a))typedef long long ll;using namespace std;long long a[100005];int gcd(long long u,long long v){if(v==0)return u;return gcd(v,u%v);}int main(){long long n,i,ans=0;long long u,v;scanf("%lld",&n);for(i=0;i<n;i++)scanf("%lld",&a[i]);int flog=1;int g=a[n-1];for(i=0;i<n-1;i++)g=gcd(g,a[i]);if(g!=1){printf("YES\n0\n");return 0;}for(i=0;i<n-1;i++){if(a[i]&1){if(a[i+1]&1){ans++;a[i+1]+=a[i];}else{ans+=2;a[i+1]=2*a[i];}}}if(a[n-1]&1)ans+=2;printf("YES\n%lld\n",ans);return 0; }
不过在判断原序列最小公因子是不是大于1的地方马虎出了点小问题。。。。没过终测=。=



0 0
原创粉丝点击